Java运行时异常try-catch块能捕捉到吗

还记得2年前见过这个问题,当时没太在意,这次写demo复现了这个问题。Java运行时异常能捕捉吗?

背景:比如文件上传后的删除操作deleteid不存在抛出运行时异常。 删除方法是public void delete(),因为MVC中的Model层没有声明异常,service中的delete调用dao中的deletedao中的delete去调用xml或者数据库delete操作。现在前端需要接收到删除成功和失败的提示,后端删除失败是会有运行时异常的,最后需要给前端返回类似{return:"ok"}或者{return:"你的异常信息"}

方法大概两种,第一就是删除数据失败直接返回boolean类型值,方法改为public boolean delete(),第二种就是把运行时异常一层层上抛到Controller进行try-catch处理,在catch块中返回错误的json数据{return:"你的异常信息"}


思考的问题来了,运行时异常一层层往上抛出,try-catch能接住吗?如果接不住你就没法处理失败信息传给前端了。那咱们就来试一试。

public class HelloWorld{

	public static void test() {
		try {
			throw new RuntimeException("test RuntimeException123");
		} catch (RuntimeException e) {
			System.out.println("里面");
			throw new RuntimeException(e.getMessage());
		} catch (Exception f) {
			System.out.println("ff");
		}
	}
	public static void test2() {
		System.out.println("执行到test2");
		test();
		System.out.println("test()抛异常后面还会执行吗?");
	}
	public static void main(String[] args) {
		try {
			test2();
		} catch(Exception e) {
			e.printStackTrace();
			System.out.println("外面");
		}
	}
}

java运行时异常能捕捉吗
结果我们发现,test()中,运行时异常被try-catch接住了,然后继续往上抛,在test2()中没有try-catch块,结果在main方法还是能接住。


得出结论:
  运行时异常不需要throws声明,即使是方法层层调用,也能抛出到最上层后再用try-catch捕捉。所以,运行时异常可以捕捉,但是没必要捕捉,除非功能特殊需要。

  说到这里,我得再提示一下,像这种运行时异常RuntimeException是非受检查异常,编译器不能提前预测。在SpringBoot中自定义异常进行统一异常处理时,如果你的自定义异常是extends Exception,那么你每次throw抛出异常编译器都会提示要try-catch或者throws声明,特别麻烦,如果我们只是需要最终只是在统一异常处理类里面进行处理,返回给前端统一的json异常信息,那么完全可以将自定义异常extends RuntimeException,这样每次throw new "自定义异常"就不用try-catch或者throws声明了,因为RuntimeException是可以捕捉且编译器不提前预测的,这样就不会抛出异常时爆红了。


欢迎一键三连~

有问题请留言,大家一起探讨学习

----------------------Talk is cheap, show me the code-----------------------
相关推荐
©️2020 CSDN 皮肤主题: 数字20 设计师:CSDN官方博客 返回首页